---
title: 'ReferenceError: "x" is not defined'
slug: Web/JavaScript/Reference/Errors/Not_defined
tags:
  - Error
  - JavaScript
  - ReferenceError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "<em>variable</em> is not defined" occurs when there is a non-existent variable referenced somewhere.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox notranslate">ReferenceError: "x" is not defined
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("ReferenceError")}}.</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>There is a non-existent variable referenced somewhere. This variable needs to be declared, or you need to make sure it is available in your current script or <a href="/en-US/docs/Glossary/scope">scope</a>.</p>

<div class="note">
<p><strong>Note:</strong> When loading a library (such as jQuery), make sure it is loaded before you access library variables, such as "$". Put the {{HTMLElement("script")}} element that loads the library before your code that uses it.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Variable_not_declared">Variable not declared</h3>

<pre class="brush: js example-bad notranslate">foo.substring(1); // ReferenceError: foo is not defined
</pre>

<p>The "foo" variable isn't defined anywhere. It needs to be some string, so that the {{jsxref("String.prototype.substring()")}} method will work.</p>

<pre class="brush: js example-good notranslate">var foo = 'bar';
foo.substring(1); // "ar"</pre>

<h3 id="Wrong_scope">Wrong scope</h3>

<p>A variable needs to be available in the current context of execution. Variables defined inside a <a href="/en-US/docs/Web/JavaScript/Reference/Functions">function</a> cannot be accessed from anywhere outside the function, because the variable is defined only in the scope of the function</p>

<pre class="brush: js example-bad notranslate">function numbers() {
  var num1 = 2,
      num2 = 3;
  return num1 + num2;
}

console.log(num1); // ReferenceError num1 is not defined.</pre>

<p>However, a function can access all variables and functions defined inside the scope in which it is defined. In other words, a function defined in the global scope can access all variables defined in the global scope.</p>

<pre class="brush: js example-good notranslate">var num1 = 2,
    num2 = 3;

function numbers() {
  return num1 + num2;
}

console.log(numbers()); // 5</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Glossary/Scope">Scope</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Grammar_and_types#Declaring_variables">Declaring variables in the JavaScript Guide</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions#Function_scope/en-US/docs/">Function scope in the JavaScript Guide</a></li>
</ul>
